void drawAxis() {
    pushMatrix();
//    translate(DIMENSION / 2, DIMENSION / 2, DIMENSION / 2);
    noFill();
    stroke(40, 20);
    strokeWeight(2);
//    box(DIMENSION);
    line(0, 0, 0, DIMENSION, 0, 0); // x
    line(0, 0, 0, 0, DIMENSION, 0); // y
    line(0, 0, 0, 0, 0, DIMENSION); // z
    popMatrix();

    // draw text label
    // x axis
    fill(FONT_COLOR);
    textSize(24);
    textAlign(RIGHT, BOTTOM);
    pushMatrix();
    translate(DIMENSION, -10, 0);
    text(X_LABEL, 0, 0);
    popMatrix();
    // y axis
    pushMatrix();
    translate(-10, DIMENSION, 0);
    rotate(3*HALF_PI, 0, 0, 1);
    text(Y_LABEL, 0, 0);
    popMatrix();

    // z axis
    textAlign(LEFT, BOTTOM);
    pushMatrix();
    translate(0, -10, DIMENSION);
    rotate(HALF_PI, 0, 1, 0);
    text(Z_LABEL, 0, 0);
    popMatrix();
}

void drawHUD() {
    hint(DISABLE_DEPTH_TEST);
    cam.beginHUD();
    // draw title
    textSize(TITLE_SIZE);
    textAlign(LEFT, TOP);
    fill(FONT_COLOR);
    text("Trending YouTube Videos\n2017/11/14 - 2018/06/14", 15, 15);

    cp5.draw();
    cam.endHUD();
    hint(ENABLE_DEPTH_TEST);
}

void getAndDrawChannelInfo() {
    if (g_channelName == null || !g_channelName.equals(currentName)) {
        getStats(currentName);
    }
    // draw channel info
    hint(DISABLE_DEPTH_TEST);
    cam.beginHUD();
    textSize(TITLE_SIZE);
    textAlign(RIGHT, TOP);
    fill(FONT_COLOR);
    int d = 25;
    text("Channel: " + g_channelName, width - 15, 15 + d * 0);
    text("View Count: " + g_viewCount, width - 15, 15 + d * 1);
    text("Subscriber Count: " + g_subscriberCount, width - 15, 15 + d * 2);
    text("Video Count: " + g_videoCount, width - 15, 15 + d * 3);
    PImage img = loadImage(g_thumbnailLink, "png");
    image(img, width - 15 - 240, 15 + d * 4);
    cp5.draw();
    cam.endHUD();
    hint(ENABLE_DEPTH_TEST);
}
