class Video {
    LocalDate trendingDate;
    String title;
    String channelTitle;
    int categoryId;
    int views;
    int likes;
    int dislikes;
    float ratio;
    String videoId;
    int duration;
    float x, y, z;
    color c;

    Video(LocalDate td, String t, String ct, int ci, int v, int l, int d, String vi, int du) {
        this.trendingDate = td;
        this.title = t;
        this.channelTitle = ct;
        this.categoryId = ci;
        this.views = v;
        this.likes = l;
        this.dislikes = d;
        this.ratio = likes / (float) dislikes;
        this.videoId = vi;
        this.duration = du;
        setColor();
    }

    void render(int alpha) {
        if (shouldSkip()) return;
        pushMatrix();
        this.x = constrain(map(this.ratio, minRatio, maxRatio, 0, DIMENSION), 0, DIMENSION);
        this.y = constrain(map(log(this.views), log(minViews), log(maxViews), 0, DIMENSION), 0, DIMENSION);
        this.z = constrain(map(daysBetween(earliestDate, this.trendingDate), 0, maxDays, 0, DIMENSION), 0, DIMENSION);
        translate(this.x, this.y, this.z);
        strokeWeight(2);
        stroke(this.c, alpha);
        point(0, 0, 0);
        if (displayState == DisplayState.ALL || displayState == DisplayState.CURRENT && this.videoId.equals(currentId)) {
            float mouseDist = sq(mouseX-screenX(0, 0, 0))+sq(mouseY-screenY(0, 0, 0));
            if (mouseDist < 20) {
                pushMatrix();
                rotations = cam.getRotations();
                rotateX(rotations[0]);
                rotateY(rotations[1]);
                rotateZ(rotations[2]);
                stroke(this.c, 255);
                strokeWeight(10);
                point(0,0,0);
                stroke(0,0,0,0);
                fill(255,255,255);
                textMode(SHAPE);
                textSize(24);
                fill(FONT_COLOR);
                text(this.title + "\nViews: " + String.valueOf(this.views) + " | Likes: " + String.valueOf(this.likes) + " | Dislikes: " + String.valueOf(this.dislikes) + "\nTrending Date: " + this.trendingDate.format(DateTimeFormatter.ofPattern("yyyy-MM-dd")),0,0);
                try {
                    PImage img = loadImage("https://img.youtube.com/vi/"+this.videoId+"/hqdefault.jpg");
                    image(img, 0, 110);
                } catch (NullPointerException e) {}
                finally {
                    popMatrix();
                }
                if (mousePressed) {
                    if (mouseButton == LEFT) {
                        currentId = this.videoId;
                        currentName = this.channelTitle;
                        displayState = DisplayState.CURRENT;
                    }
                }
            }
        }
        popMatrix();
    }

    void setColor() {
        switch (this.categoryId) {
            case 2:
            case 19:
            case 29:
            case 43:
                this.c = #ffffff;
                break;
            case 1:
                this.c = #a6cee3;
                break;
            case 10:
                this.c = #1f78b4;
                break;
            case 15:
                this.c = #b2df8a;
                break;
            case 17:
                this.c = #33a02c;
                break;
            case 20:
                this.c = #fb9a99;
                break;
            case 22:
                this.c = #e31a1c;
                break;
            case 23:
                this.c = #fdbf6f;
                break;
            case 24:
                this.c = #ff7f00;
                break;
            case 25:
                this.c = #cab2d6;
                break;
            case 26:
                this.c = #6a3d9a;
                break;
            case 27:
                this.c = #ffff99;
                break;
            case 28:
                this.c = #b15928;
                break;
        }
    }

    boolean shouldSkip() {
        if (this.categoryId == 1 && !toggle_1) return true;
        else if (this.categoryId == 2 || this.categoryId == 19 || this.categoryId == 29 || this.categoryId == 43 && !toggle_2) return true;
        else if (this.categoryId == 10 && !toggle_10) return true;
        else if (this.categoryId == 15 && !toggle_15) return true;
        else if (this.categoryId == 17 && !toggle_17) return true;
        else if (this.categoryId == 20 && !toggle_20) return true;
        else if (this.categoryId == 22 && !toggle_22) return true;
        else if (this.categoryId == 23 && !toggle_23) return true;
        else if (this.categoryId == 24 && !toggle_24) return true;
        else if (this.categoryId == 25 && !toggle_25) return true;
        else if (this.categoryId == 26 && !toggle_26) return true;
        else if (this.categoryId == 27 && !toggle_27) return true;
        else if (this.categoryId == 28 && !toggle_28) return true;
        else return false;
    }
}
