void getStats(String channelName) {
    try {
        GetRequest get = new GetRequest("https://www.googleapis.com/youtube/v3/channels?part=snippet,contentDetails,statistics&forUsername=" + URLEncoder.encode(channelName, "UTF-8") + "&key=" + API_KEY);
        get.send();
        org.json.JSONObject result = new JSONObject(get.getContent());
        g_channelName = channelName;
        setGlobals(result);
    } catch (Exception e) {
        e.printStackTrace();
    }
}

void setGlobals(org.json.JSONObject obj) {
    int totalResults = obj.getJSONObject("pageInfo").getInt("totalResults");
    if (totalResults == 0) {
        g_viewCount = 0;
        g_subscriberCount = 0;
        g_videoCount = 0;
        g_thumbnailLink = "https://yt3.ggpht.com/a-/AAuE7mB9WSnjk6VfFfP1k2uSFfBpgr5pejFcB6CDvw=s240-mo-c-c0xffffffff-rj-k-no";
    } else {
        org.json.JSONObject item = obj.getJSONArray("items").getJSONObject(0);
        org.json.JSONObject statistics = item.getJSONObject("statistics");
        g_viewCount = Long.parseLong(statistics.getString("viewCount"));
        g_subscriberCount = Long.parseLong(statistics.getString("subscriberCount"));
        g_videoCount = Long.parseLong(statistics.getString("videoCount"));
        org.json.JSONObject thumbnails = item.getJSONObject("snippet").getJSONObject("thumbnails");
        g_thumbnailLink = thumbnails.getJSONObject("medium").getString("url");
    }
}


